
literal_double		macro	lit_double:vararg
			local	local_double

			.data
local_double		real8	lit_double

			.code
			exitm	<local_double>
			endm
			
literal_float		MACRO	lit_float:VARARG
			LOCAL	local_float
			.data
local_float		real4	lit_float
			.code
			EXITM	<local_float>
			ENDM

CFLT			MACRO	lit_float:VARARG
			EXITM	<literal_float(lit_float)>
			ENDM
			
CTEXT MACRO y:VARARG
	LOCAL sym

	CONST segment
		IFIDNI <y>,<>
			sym db 0
		ELSE
			sym db y,0
		ENDIF
	CONST ends

	EXITM <OFFSET sym>
ENDM

CDBL			macro	lit_double:vararg
			exitm	<literal_double(lit_double)>
			endm


InitControlFrb proto hWnd:HWND
GetMainScreenAddress proto
GetBitMapAddress proto
GetBitMapHandle proto
GetMainScreenDC proto

frbPixelPut proto x:dword,y:dword,color:dword
frbPixelPut2 proto x:dword,y:dword,color:dword

fCreateLayer proto hWnd:dword,x:dword,y:dword,w:dword,h:dword
fLayerGetDC proto hndlyr :dword
fLayerGetBmp proto hndlyr :dword
fLayerGetBIH proto hndlyr :dword
fLayerGetBIHHeigth proto hndlyr:dword
fLayerGetBIHWidth proto hndlyr:dword
fLayerGetDimension proto hndlyr:dword
fLayerGetBitmapPointer proto hndlyr:dword
fDestroyLayer proto hndlyr:dword

Line proto x:dword,y:dword,x2:dword,y2:dword,color:dword
Line2 proto x:dword,y:dword,x2:dword,y2:dword,color:dword
fGradientRect proto x:dword,y:Dword,w:dword,h:dword,color:dword
TransferPixel proto dest:dword,sou:dword,machine_used:dword
TransferPixelFull proto
BlankScreen proto

advFrbPixelBuffer proto x:dword,y:dword,color:dword,nCommand:dword
RotateObject PROto ListNumber:DWORD,XYZPosition:DWORD,XYZRotations:DWORD,XYZAngles:DWORD

Load_File proto :dword,:dword
NewLayer proto :Dword,:Dword

; system screen
GetBitmapPointer proto
SetBitmapPointer proto :Dword

; fBitmap
CreatefBitmap proto w:dword,h:dword
DestroyfBitmap proto :dword


.data?
	prosesor_type dword ?
	main_screen dword ?
	mscr_x dword ?
	mscr_y dword ?
	mscr_bit dword ?
	mDCGUI dword ?
	hBmpGUI dword ?
	mDCGUI2 dword ?
	hBmpGUI2 dword ?
	pointer_bitmap dword ?
	pointer_bitmap2 dword ?
	
	keybrd_buff dword ?
	
	bih BITMAPINFOHEADER <?>
	
	FontStrucGUI	LOGFONT <-12,0,0,0,FW_NORMAL,0,0,0,DEFAULT_CHARSET,OUT_STROKE_PRECIS,CLIP_DEFAULT_PRECIS,DRAFT_QUALITY,DEFAULT_PITCH+FF_SWISS,"Lucida Console">
	hDC dword ?
	
	FntHnd1 dword ?
	FntHnd2 dword ?
.data
	frbsnd db 'waveaudio',0
	
pfd			PIXELFORMATDESCRIPTOR <	sizeof PIXELFORMATDESCRIPTOR, \
						1, \
						PFD_DRAW_TO_WINDOW or PFD_SUPPORT_OPENGL or PFD_DOUBLEBUFFER or PFD_SWAP_EXCHANGE, \
						PFD_TYPE_RGBA, \
						0, \
						0, 0, 0, 0, 0, 0, \
						0, \
						0, \
						0, \
						0, 0, 0, 0, \
						24, \
						0, \
						0, \
						0, \
						0, \
						0, 0, 0 >

hRC dd 0

.code

; Use mDCGUI2 for manipulating pixel
; Copy it to mDCGUI after finish
MakeFont proc pointSize:DWORD,weight:DWORD,italic:DWORD,lpFontName:DWORD

    invoke GetDC, 0
    invoke GetDeviceCaps,eax,LOGPIXELSY
    mul pointSize
    xor edx, edx
    mov ecx, 72
    div ecx

    invoke CreateFont,eax,0,NULL,NULL,weight,italic,NULL,NULL,
                      DEFAULT_CHARSET,OUT_TT_PRECIS,CLIP_DEFAULT_PRECIS,
                      PROOF_QUALITY,DEFAULT_PITCH or FF_DONTCARE,
                      lpFontName
    ret

MakeFont endp

InitKeyboard proc
	
	invoke mAlloc,512
	mov keybrd_buff,eax
	
	ret
InitKeyboard endp

IsPressed proc uses esi key:dword

	mov esi,keybrd_buff
	mov eax,key
	movzx eax,byte ptr[esi+eax]
	
	ret
IsPressed endp

IsSupportMMX proc
	
   push   ebx                  
    push   ecx
    push   edx

    ; Check feature flag 23 in EDX for MMX support
    mov    eax, 1               
    cpuid                       
    mov    eax, edx           
    shr    eax, 23              
    and    eax, 1                   

    ; Restore registers
    pop    edx                  
    pop    ecx
    pop    ebx
    ret
	
	ret
IsSupportMMX endp

EndMMX proc
	
    emms     ; Allow CPU to use floating point
    ret
	
	ret
EndMMX endp




fSetDC proc wDC:dword
	push wDC
	pop hDC
	ret
fSetDC endp

InitControlFrb proc hWnd:HWND

	LOCAL mDC:dword,hOld:dword 
	LOCAL r:RECT 
	LOCAL Text[1024]:dword 
	LOCAL posX,posY,clr,xc,yc,xc2,yc2,xc3,yc3,xc4,yc4,co:dword 
	LOCAL pbm,PixFormat,tmpDC:dword
	LOCAL WINRect:RECT

	invoke GlobalAlloc,GMEM_ZEROINIT or GMEM_FIXED,(1024*768*4)*2
	mov main_screen,eax
	
	
	invoke GetDC,hWnd
 	mov tmpDC,eax 
	
	invoke CreateCompatibleDC,tmpDC
	mov mDCGUI,eax
	invoke GetClientRect,hWnd,addr r 
	mov eax,1024		;r.right
	mov mscr_x,eax
	mov eax,768			;r.bottom
	mov mscr_y,eax	
	
	mov mscr_bit,32
	
	mov bih.biSize,sizeof BITMAPINFOHEADER
	push 1024
	pop bih.biWidth
	push 768
	pop bih.biHeight
	mov bih.biPlanes,1
	mov bih.biBitCount,32
	mov bih.biCompression,BI_RGB
	mov bih.biSizeImage,0
	mov bih.biXPelsPerMeter,0
	mov bih.biYPelsPerMeter,0
	mov bih.biClrUsed,0
	mov bih.biClrImportant,0
	invoke CreateDIBSection,mDCGUI,addr bih,DIB_RGB_COLORS,addr pointer_bitmap,0,0
	mov hBmpGUI,eax
		
	invoke SelectObject,mDCGUI,hBmpGUI 
	mov hOld,eax
	
	; OpenGL Init
	invoke ChoosePixelFormat,tmpDC,addr pfd
	.if eax==0
		invoke MessageBox,0,CADD("Pixel format error 1"),0,0
	.endif
	mov edx,eax
	invoke SetPixelFormat,tmpDC,edx,addr pfd
	.if eax==0
		invoke MessageBox,0,CADD("Pixel format error 2"),0,0
	.endif
	invoke wglCreateContext,tmpDC
	.if eax==0
		invoke MessageBox,0,CADD("Create Context Error"),0,0
	.endif
	mov hRC,eax
	invoke wglMakeCurrent,tmpDC,hRC
	.if eax==FALSE
		invoke MessageBox,0,CADD("Make Current Error"),0,0
	.endif
	
	;
	
	invoke SetBkMode,mDCGUI,TRANSPARENT 
	invoke SetTextColor,mDCGUI,0FF00h
	invoke CreateFontIndirect,addr FontStrucGUI
	mov FntHnd1,eax
	invoke SelectObject,mDCGUI,eax

;	invoke ReleaseDC,hWnd,tmpDC
	
	
;	invoke GetDC,hWnd
;	mov tmpDC,eax 
	
	invoke CreateCompatibleDC,tmpDC
	mov mDCGUI2,eax
	invoke GetClientRect,hWnd,addr r 
	mov eax,1024		;r.right
	mov mscr_x,eax
	mov eax,768			;r.bottom
	mov mscr_y,eax	
	
	mov mscr_bit,32
	
	mov bih.biSize,sizeof BITMAPINFOHEADER
	push 1024
	pop bih.biWidth
	push 768
	pop bih.biHeight
	mov bih.biPlanes,1
	mov bih.biBitCount,32
	mov bih.biCompression,BI_RGB
	mov bih.biSizeImage,0
	mov bih.biXPelsPerMeter,0
	mov bih.biYPelsPerMeter,0
	mov bih.biClrUsed,0
	mov bih.biClrImportant,0
	invoke CreateDIBSection,mDCGUI2,addr bih,DIB_RGB_COLORS,addr pointer_bitmap2,0,0
	mov hBmpGUI2,eax
		
	invoke SelectObject,mDCGUI2,hBmpGUI2
	mov hOld,eax
	
	
	
	invoke SetBkMode,mDCGUI2,TRANSPARENT 
	invoke SetTextColor,mDCGUI2,0FF00h
	invoke CreateFontIndirect,addr FontStrucGUI
	mov FntHnd2,eax
	invoke SelectObject,mDCGUI2,eax
;	invoke ReleaseDC,hWnd,tmpDC
	 	
	invoke Phase1
	
	invoke InitKeyboard
	
	ret
InitControlFrb endp

InputMouseFrb proc lParam:dword
	
		mov eax,lParam
		mov edx,eax
		and eax,0FFFFh
		
		shr edx,16
		
	
	ret
InputMouseFrb endp

InputKeyboadFrb proc wParam:dword,code:dword
		mov esi,keybrd_buff
		mov eax,wParam
		mov ecx,code
		mov byte ptr[esi+eax],cl
	ret
InputKeyboadFrb endp

; All Frank Charles code is here.
; Please note that he is not responsible for any damage in this code
; because this code is implemented by Onan Farabi for all to made OpenGL
; application easier. By the way, Im not responsible for any damage too.


; Name: Change_Screen_Resolution()
; Desc: Resize the screen with given dimensions and depth
Change_Screen_Resolution proc	w:dword, h:dword, bitsPerPixel:dword
			local	dmScreenSettings:DEVMODE

			invoke	RtlZeroMemory,addr dmScreenSettings, sizeof DEVMODE
			mov	dmScreenSettings.dmSize, sizeof DEVMODE
			mov	eax,w
			mov	dmScreenSettings.dmPelsWidth,eax
			mov	eax,h
			mov	dmScreenSettings.dmPelsHeight,eax
			mov	eax,bitsPerPixel
			mov	dmScreenSettings.dmBitsPerPel,eax
			mov	dmScreenSettings.dmFields, 040000h or 080000h or 0100000h
			invoke	ChangeDisplaySettings,addr dmScreenSettings, 4
			.if	eax != DISP_CHANGE_SUCCESSFUL
				xor	eax,eax
			.else
				mov	eax,TRUE
			.endif
			ret
Change_Screen_Resolution endp
