
        MIXER_ERROR equ 0FFFFFFFFh 
        SPEAKEROUTLINEID equ 0FFFF0000h

.data
szMIDISeqr  	db "Sequencer",0
szWaveFormat	db "waveaudio",0
szMP3Format 	db "MPEGVideo2",0

        mxc MIXERCONTROL <?>
        mxcd MIXERCONTROLDETAILS <?>
        mxcdVol MIXERCONTROLDETAILS_UNSIGNED <?>
        mxlc MIXERLINECONTROLS <?>

        MixerHandle    dd 0
        VolCtlIDMtr    dd 0
.code

LoadMidiFile proc hWin:DWORD,NameOfFile:DWORD
	LOCAL mciOpenParms:MCI_OPEN_PARMS,mciPlayParms:MCI_PLAY_PARMS
	LOCAL MidDeviceID:dword
	
	mov eax,hWin        
	mov mciPlayParms.dwCallback,eax
	mov eax,OFFSET szMIDISeqr
	mov mciOpenParms.lpstrDeviceType,eax
	mov eax,NameOfFile
	mov mciOpenParms.lpstrElementName,eax
	invoke mciSendCommand,0,MCI_OPEN,MCI_OPEN_TYPE or MCI_OPEN_ELEMENT,ADDR mciOpenParms
	mov eax,mciOpenParms.wDeviceID
	mov MidDeviceID,eax
	invoke mciSendCommand,MidDeviceID,MCI_PLAY,MCI_NOTIFY,ADDR mciPlayParms
	
	mov eax,MidDeviceID
	ret 
LoadMidiFile endp

LoadWaveFile proc hWin:dword,NameOfFile:dword
	LOCAL mciOpenParms:MCI_OPEN_PARMS,mciPlayParms:MCI_PLAY_PARMS
	LOCAL MidDeviceID:dword
	
	mov eax,hWin        
	mov mciPlayParms.dwCallback,eax
	mov eax,OFFSET szWaveFormat
	mov mciOpenParms.lpstrDeviceType,eax
	mov eax,NameOfFile
	mov mciOpenParms.lpstrElementName,eax
	invoke mciSendCommand,0,MCI_OPEN,MCI_OPEN_TYPE or MCI_OPEN_ELEMENT,ADDR mciOpenParms
	mov eax,mciOpenParms.wDeviceID
	mov MidDeviceID,eax
	invoke mciSendCommand,MidDeviceID,MCI_PLAY,MCI_NOTIFY,ADDR mciPlayParms
	
	mov eax,MidDeviceID
	
	ret
LoadWaveFile endp

LoadMP3File proc hWin:dword,NameOfFile:dword
	LOCAL mciOpenParms:MCI_OPEN_PARMS,mciPlayParms:MCI_PLAY_PARMS
	LOCAL MidDeviceID:dword
	
	mov eax,hWin        
	mov mciPlayParms.dwCallback,eax
	mov eax,OFFSET szMP3Format
	mov mciOpenParms.lpstrDeviceType,eax
	mov eax,NameOfFile
	mov mciOpenParms.lpstrElementName,eax
	invoke mciSendCommand,0,MCI_OPEN,MCI_OPEN_TYPE or MCI_OPEN_ELEMENT,ADDR mciOpenParms
	mov eax,mciOpenParms.wDeviceID
	mov MidDeviceID,eax
	
	ret
LoadMP3File endp

PlayFile proc hWnd:dword,MidDeviceID:dword
	LOCAL mciPlayParms:MCI_PLAY_PARMS
	
	mov eax,hWnd
	mov mciPlayParms.dwCallback,eax
	invoke mciSendCommand,MidDeviceID,MCI_PLAY,MCI_NOTIFY,ADDR mciPlayParms	
	ret
PlayFile endp

RepeatFile proc hWnd:dword,MidDeviceID:dword
	LOCAL mciPlayParms:MCI_PLAY_PARMS
	
	mov eax,hWnd
	mov mciPlayParms.dwCallback,eax
	
	Invoke mciSendCommand, MidDeviceID, MCI_SEEK, MCI_SEEK_TO_START, addr mciPlayParms
	Invoke mciSendCommand, MidDeviceID, MCI_PLAY, MCI_NOTIFY, addr mciPlayParms	
	ret
RepeatFile endp

StopFile proc MidDeviceID:dword	
	invoke mciSendCommand,MidDeviceID,MCI_STOP,0,0	
	ret
StopFile endp

CloseFile proc MidDeviceID:dword
	invoke mciSendCommand,MidDeviceID,MCI_CLOSE,0,0
	ret
CloseFile endp

PauseFile proc MidDeviceID:dword	
	invoke mciSendCommand,MidDeviceID,MCI_PAUSE,0,0
	ret
PauseFile endp

ResumeFile proc MidDeviceID:dword
	invoke mciSendCommand,MidDeviceID,MCI_PAUSE,0,0	
	ret
ResumeFile endp

RenderToWindow proc hWnd:dword,MidDeviceID:dword
	LOCAL m2:MCI_OVLY_WINDOW_PARMS
	
	push hWnd
	pop m2.dwCallback
	push hWnd
	pop m2.hwnd
	push 0
	pop m2.nCmdShow
	push 0
	pop m2.lpstrText
	invoke mciSendCommand,MidDeviceID,MCI_WINDOW,MCI_OVLY_WINDOW_HWND or MCI_NOTIFY,addr m2
	
	ret
RenderToWindow endp

;Code by Wiliam F.
GetMasterVolume proc

        invoke mixerOpen,ADDR MixerHandle,0,0,0,0
        .if eax == MMSYSERR_NOERROR 
            mov mxlc.cbStruct,SIZEOF mxlc
            mov mxlc.dwLineID,SPEAKEROUTLINEID
            mov mxlc.dwControlType,MIXERCONTROL_CONTROLTYPE_VOLUME
            mov mxlc.cControls,1
            mov mxlc.cbmxctrl,SIZEOF mxc
            mov mxlc.pamxctrl,OFFSET mxc
            invoke mixerGetLineControls,MixerHandle,ADDR mxlc,MIXER_GETLINECONTROLSF_ONEBYTYPE
            mov eax,mxc.dwControlID
            mov VolCtlIDMtr,eax
            mov mxcdVol.dwValue,1
            mov mxcd.cbStruct,SIZEOF mxcd
            mov eax,VolCtlIDMtr  
            mov mxcd.dwControlID,eax
            mov mxcd.cChannels,1
            mov mxcd.cMultipleItems,0
            mov mxcd.cbDetails,SIZEOF mxcdVol
            mov mxcd.paDetails,OFFSET mxcdVol
            invoke mixerGetControlDetails,MixerHandle,ADDR mxcd,MIXER_GETCONTROLDETAILSF_VALUE
            mov eax,mxcdVol[0].dwValue
        .else
            mov eax,MIXER_ERROR
        .endif
        ret

GetMasterVolume endp
    
; ###############################################################

SetMasterVolume proc VolValue:DWORD

        mov eax,VolValue
        mov mxcdVol[0].dwValue,eax
        mov mxcd.cbStruct,SIZEOF mxcd
        mov eax,VolCtlIDMtr
        mov mxcd.dwControlID,eax
        mov mxcd.cChannels,1
        mov mxcd.cMultipleItems,0
        mov mxcd.cbDetails,SIZEOF mxcdVol
        mov mxcd.paDetails,OFFSET mxcdVol
        invoke mixerSetControlDetails,MixerHandle,ADDR mxcd,MIXER_GETCONTROLDETAILSF_VALUE
        .if eax == MMSYSERR_NOERROR
            mov eax,0
        .else
            mov eax,MIXER_ERROR
        .endif            
        ret

SetMasterVolume endp

; ###############################################################

CloseMasterVolume proc

        invoke mixerClose,ADDR MixerHandle
        ret

CloseMasterVolume endp