streamtypeVIDEO equ 1935960438

fAVIS struct
	avihnd dword 0
	pAVIStream dword 0
	firstframe dword 0
	totalframe dword 0
	pGetFrameObject dword 0
fAVIS ends

.data?
	m_hdrawdib dword 0

.code

fInitVideo proc
	invoke AVIFileInit
	invoke DrawDibOpen
	.if eax!=0
		mov m_hdrawdib,eax
	.else
		invoke PERR
	.endif
	
	ret
fInitVideo endp

fAviFileOpen proc uses esi edi lps:dword,lptz:dword
	
	assume esi: ptr fAVIS
	
	mov esi,lps
	lea eax,[esi].avihnd
	
	invoke AVIFileOpen,eax,lptz,OF_SHARE_DENY_WRITE,NULL
	.if eax!=0
		invoke PERR
		ret
	.endif
	
	lea eax,[esi].pAVIStream
	invoke AVIFileGetStream,[esi].avihnd,eax,streamtypeVIDEO,0
	.if eax!=0
		invoke PERR
	.endif
	invoke AVIStreamStart,[esi].pAVIStream
	.if eax==-1
		invoke PERR
	.endif
	mov [esi].firstframe,eax
	invoke AVIStreamLength,[esi].pAVIStream
	.if eax==-1
		invoke PERR
	.endif
	mov [esi].totalframe,eax
	
	invoke AVIStreamGetFrameOpen,[esi].pAVIStream,NULL ;AVIGETFRAMEF_BESTDISPLAYFMT
	.if eax!=NULL
		mov [esi].pGetFrameObject,eax
	.else
		invoke PERR
	.endif
	
	assume esi:nothing
	
	ret
fAviFileOpen endp

fAVIClose proc uses esi lps:dword
	
	assume esi:ptr fAVIS
	
	invoke AVIStreamGetFrameClose,[esi].pGetFrameObject
	invoke AVIStreamRelease,[esi].pAVIStream
	invoke AVIFileRelease,[esi].avihnd
	
	assume esi:nothing
	
	ret
fAVIClose endp


fAVIDraw proc uses esi edi lps:dword,FramePos:dword,DC:dword,x:dword,y:dword,xDst:dword,yDst:dword,xSrc:dword,ySrc:dword
	LOCAL lpbi:dword
	
	assume esi:ptr fAVIS
	mov esi,lps
	mov eax,[esi].totalframe
	.if FramePos>eax
		xor eax,eax
		dec eax
		ret
	.endif
	
	invoke AVIStreamGetFrame,[esi].pGetFrameObject,FramePos
	mov lpbi,eax
	invoke DrawDibDraw,m_hdrawdib,DC,x,y,xDst,yDst,lpbi,NULL,xSrc,ySrc,-1,-1,0
	assume esi:nothing
	xor eax,eax
	
	ret
fAVIDraw endp

