include ws2_32.inc
include mapi32.inc

includelib ws2_32.lib
includelib mapi32.lib

WM_FSOCKET equ WM_USER + 0fh

CURL_GLOBAL_SSL	EQU	( 1  shl  0 )
CURL_GLOBAL_WIN32	EQU	( 1  shl  1 )
CURL_GLOBAL_ALL	EQU	( CURL_GLOBAL_SSL  or  CURL_GLOBAL_WIN32 )
CURL_GLOBAL_NOTHING	EQU	0
CURL_GLOBAL_DEFAULT	EQU	<CURL_GLOBAL_ALL>
curl_lock_data typedef DWORD
CURL_LOCK_DATA_NONE = 0 
CURL_LOCK_DATA_SHARE = 1
CURL_LOCK_DATA_COOKIE = 2
CURL_LOCK_DATA_DNS = 3
CURL_LOCK_DATA_SSL_SESSION = 4
CURL_LOCK_DATA_CONNECT = 5
CURL_LOCK_DATA_LAST = 6

CURLOPT_VERBOSE = 41
CURLOPT_HEADER = 42
CURLOPT_NOPROGRESS = 43

CURLOPTTYPE_OBJECTPOINT	EQU	10000

CURLOPT_URL = 10000 + 2
CURLOPT_HTTPPOST equ 10000 + 24
CURLOPT_UPLOAD = 46
CURLOPT_READDATA = 10000+9
CURLOPT_INFILESIZE = 14
CURLOPT_INFILESIZE_LARGE = 30000 +115
CURLOPT_POSTFIELDS equ 10000 + 15
CURLOPT_POSTFIELDSIZE = 60
CURLOPT_HTTPHEADER = 10000+23
CURLOPT_POST = 47

CURLINFO_STRING	EQU	100000h
CURLINFO_LONG	EQU	200000h
CURLINFO_DOUBLE	EQU	300000h
CURLINFO_SLIST	EQU	400000h
CURLINFO_MASK	EQU	0fffffh
CURLINFO_TYPEMASK	EQU	0f00000h
CURLINFO typedef DWORD
CURLINFO_NONE = 0
CURLINFO_EFFECTIVE_URL = CURLINFO_STRING + 1 
CURLINFO_RESPONSE_CODE = CURLINFO_LONG + 2 
CURLINFO_TOTAL_TIME = CURLINFO_DOUBLE + 3 
CURLINFO_NAMELOOKUP_TIME = CURLINFO_DOUBLE + 4 
CURLINFO_CONNECT_TIME = CURLINFO_DOUBLE + 5 
CURLINFO_PRETRANSFER_TIME = CURLINFO_DOUBLE + 6 
CURLINFO_SIZE_UPLOAD = CURLINFO_DOUBLE + 7 
CURLINFO_SIZE_DOWNLOAD = CURLINFO_DOUBLE + 8 
CURLINFO_SPEED_DOWNLOAD = CURLINFO_DOUBLE + 9 
CURLINFO_SPEED_UPLOAD = CURLINFO_DOUBLE + 10 
CURLINFO_HEADER_SIZE = CURLINFO_LONG + 11 
CURLINFO_REQUEST_SIZE = CURLINFO_LONG + 12 
CURLINFO_SSL_VERIFYRESULT = CURLINFO_LONG + 13 
CURLINFO_FILETIME = CURLINFO_LONG + 14 
CURLINFO_CONTENT_LENGTH_DOWNLOAD = CURLINFO_DOUBLE + 15 
CURLINFO_CONTENT_LENGTH_UPLOAD = CURLINFO_DOUBLE + 16 
CURLINFO_STARTTRANSFER_TIME = CURLINFO_DOUBLE + 17 
CURLINFO_CONTENT_TYPE = CURLINFO_STRING + 18 
CURLINFO_REDIRECT_TIME = CURLINFO_DOUBLE + 19 
CURLINFO_REDIRECT_COUNT = CURLINFO_LONG + 20 
CURLINFO_PRIVATE = CURLINFO_STRING + 21 
CURLINFO_HTTP_CONNECTCODE = CURLINFO_LONG + 22 
CURLINFO_HTTPAUTH_AVAIL = CURLINFO_LONG + 23 
CURLINFO_PROXYAUTH_AVAIL = CURLINFO_LONG + 24 
CURLINFO_OS_ERRNO = CURLINFO_LONG + 25 
CURLINFO_NUM_CONNECTS = CURLINFO_LONG + 26 
CURLINFO_SSL_ENGINES = CURLINFO_SLIST + 27 
CURLINFO_COOKIELIST = CURLINFO_SLIST + 28 
CURLINFO_LASTSOCKET = CURLINFO_LONG + 29 
CURLINFO_FTP_ENTRY_PATH = CURLINFO_STRING + 30 
CURLINFO_REDIRECT_URL = CURLINFO_STRING + 31 
CURLINFO_PRIMARY_IP = CURLINFO_STRING + 32 
CURLINFO_APPCONNECT_TIME = CURLINFO_DOUBLE + 33 
CURLINFO_CERTINFO = CURLINFO_SLIST + 34 
CURLINFO_CONDITION_UNMET = CURLINFO_LONG + 35 
CURLINFO_LASTONE = 35 

CURLINFO_HTTP_CODE	EQU	<CURLINFO_RESPONSE_CODE>

CURLFORM_COPYNAME equ 0
CURLFORM_PTRNAME equ 1
CURLFORM_NAMELENGTH equ 2
CURLFORM_COPYCONTENTS equ 3
CURLFORM_PTRCONTENTS equ 4
CURLFORM_CONTENTSLENGTH equ 5
CURLFORM_FILECONTENT equ 6
CURLFORM_ARRAY equ 7
CURLFORM_OBSOLETE equ 8
CURLFORM_FILE equ 9
CURLFORM_BUFFER equ 10
CURLFORM_BUFFERPTR equ 11
CURLFORM_BUFFERLENGTH equ 12
CURLFORM_CONTENTTYPE equ 13
CURLFORM_CONTENTHEADER equ 14
CURLFORM_FILENAME equ 15
CURLFORM_END equ 16
CURLFORM_OBSOLETE2 equ 17
CURLFORM_STREAM equ 18
CURLFORM_LASTENTRY equ 19


curl_httppost struct
	next 	dd 0
	_name 	dd 0
	namelength	dd 0
	content		dd 0
	contentslength 	dd 0
	buffer			dd 0
	bufferlength	dd 0
	contenttype		dd 0
	contentheader	dd 0
	more			dd 0
	flags			dd 0
	HTTPPOST_FILENAME	dd 0
	HTTPPOST_READFILE	dd 0
	HTTPPOST_PTRCONTENTS	dd 0
	HTTPPOST_BUFFER			dd 0
	HTTPPOST_PTRBUFFER		dd 0
	HTTPPOST_CALLBACK		dd 0
	showfilename	dd 0
	userp			dd 0
curl_httppost ends


fInet struct
	sock dword 0
	lpszurl dword 0
fInet ends

fRequest struct
	nLenght dword 0
	lpData	dword 0
fRequest ends

.data
	wsadata WSADATA <0>
	sin sockaddr_in <0>

	MAPImsg MapiMessage <0>
	MAPIRecip MapiRecipDesc <0>
	
	hRequest2 db 'Content-Disposition: form-data; name="uploadedfile"; filename="gun.jpg" ',0,10
	hRequest3 db'User-Agent: Mozilla/5.0 (Windows; U; Windows NT 5.1; id; rv:1.9.1.7) Gecko/20091221 Firefox/3.5.7 (.NET CLR 3.5.30729)',13,10
	hRequest8 db 'Keep-Alive: 10',13,10
	hRequest9 db 'Connection: keep-alive',13,10
	hRequestA db 'Referer: Farabi Application',13,10
	; Entity
	hRequestB db 'Content-Type: multipart/form-data; boundary=---------------------------247672365515574',13,10
	hRequestC db 'Content-Length: 4',13,10
	
	LibCurl dword 0
	curl_global_init dword 0
	curl_easy_init dword 0
	curl_easy_setopt dword 0
	curl_easy_perform dword 0
	curl_slist_append dword 0
	curl_slist_free_all dword 0
	curl_easy_cleanup dword 0
	curl_easy_getinfo dword 0
	curl_formadd dword 0
	
.data?
	sock dd ?
	error_code dd ?
.code

;invoke SendRequest,CTXT("http:\\xxx.com"),CTXT("/login.php"),CTXT("username=test1&password=test2"),addr retBuf,1000

fInetGetFileSize proc hOpenUrl:dword
	LOCAL buff[128]:dword
	LOCAL brcv:dword
	
	mov brcv,1023
	invoke HttpQueryInfo,hOpenUrl,HTTP_QUERY_CONTENT_LENGTH,addr buff,addr brcv,0
	invoke atol,addr buff
	
	ret
fInetGetFileSize endp

fInetDownload proc lptz:dword
	LOCAL hOpen,hOpenUrl,brcv:dword
	LOCAL filesz,mem_handle:dword
	LOCAL buff[256]:dword
	
	invoke InternetOpen,CADD("Farabi x.0"),INTERNET_OPEN_TYPE_PRECONFIG,NULL,NULL,0
	.if eax==0
		xor eax,eax
		dec eax
		ret
	.endif
	mov hOpen,eax
	invoke InternetOpenUrl,hOpen,lptz,NULL,0,0,0
	.if eax!=0
		mov hOpenUrl,eax
		invoke fInetGetFileSize,hOpenUrl
		mov filesz,eax
			invoke mAlloc,filesize
			mov mem_handle,eax
		invoke InternetReadFile,hOpenUrl,mem_handle,filesz,addr brcv
		invoke InternetCloseHandle,hOpenUrl
		invoke InternetCloseHandle,hOpen
		
		mov eax,mem_handle
		mov ecx,filesz
	.else
		invoke InternetCloseHandle,hOpen
		xor eax,eax
		dec eax
	.endif
	
	ret
fInetDownload endp

fInetUpload proc uses esi edi	;lpFileName:dword,lpWebAddress:dword
	LOCAL hOpen,hCon,hReq,brcv:dword
	LOCAL filesz,mem_handle:dword
	LOCAL buff[256]:dword
	LOCAL ibf :INTERNET_BUFFERS
	LOCAL m:dword
	
	invoke InternetOpen,CADD("Farabi"),INTERNET_OPEN_TYPE_PRECONFIG,0,0,0
	mov hOpen,eax
	.if eax==0
		invoke MessageBox,0,CADD("InternetOpen Failed"),0,0
		invoke PostQuitMessage,0
	.endif
	;invoke InternetConnect,hOpen,CADD("antihack1221.awardspace.com"),INTERNET_DEFAULT_HTTP_PORT,0,0,INTERNET_SERVICE_HTTP,0,1
	invoke InternetConnect,hOpen,CADD("localhost"),6677,0,0,INTERNET_SERVICE_HTTP,0,1
	.if eax==0
		invoke MessageBox,0,CADD("InternetConnect"),0,0
		invoke PostQuitMessage,0
	.endif
	mov hCon,eax
	invoke HttpOpenRequest,hCon,CADD("POST"),CADD("uploader.php"),CADD("HTTP/1.1"),0,0,0,1
	.if eax==0
		invoke MessageBox,0,CADD("HttpOpenRequest Failed"),0,0
		invoke PostQuitMessage,0
	.endif
	mov hReq,eax
 	
 	
;	invoke HttpAddRequestHeaders,hReq,CADD("Content-Type: multipart/form-data; boundary=--------------------1234567"),-1,HTTP_ADDREQ_FLAG_ADD
; 	invoke HttpAddRequestHeaders,hReq,CADD("Content-Length: 4"),-1,HTTP_ADDREQ_FLAG_ADD
;	invoke HttpAddRequestHeaders,hReq,CADD("--------------------1234567"),-1,HTTP_ADDREQ_FLAG_ADD
	invoke HttpAddRequestHeaders,hReq,CADD("Content-Type: application/x-www-form-urlencoded"),-1,HTTP_ADDREQ_FLAG_ADD
	invoke HttpAddRequestHeaders,hReq,CADD('Content-Disposition: form-data; name="uploadedfile"; filename="gun.jpg"'),-1,HTTP_ADDREQ_FLAG_ADD
;	invoke HttpAddRequestHeaders,hReq,CADD("Test"),-1,HTTP_ADDREQ_FLAG_ADD
	invoke HttpAddRequestHeaders,hReq,CADD("--------------------1234567"),-1,HTTP_ADDREQ_FLAG_ADD
 	
	invoke HttpSendRequest,hReq,0,-1,CADD("Test"),4
	.if eax==0
		invoke MessageBox,0,CADD("Send request failed"),0,0
	.endif
	
	invoke InternetReadFile,hReq,addr buff,1024,addr filesz
	invoke MessageBox,0,addr buff,0,0
	
	invoke HttpEndRequest,hReq,0,0,0
	
	
	push 1024
	pop mem_handle
;	invoke HttpQueryInfo,hReq,HTTP_QUERY_STATUS_TEXT,addr buff,addr mem_handle,0
;	invoke MessageBox,0,addr buff,0,0
	
	invoke InternetCloseHandle,hCon
	invoke InternetCloseHandle,hOpen
	invoke InternetCloseHandle,hReq
	
	
	
	ret
fInetUpload endp

finetUploadFTP proc uses esi edi 
	
	
	
	ret
finetUploadFTP endp

fInitInternet proc hWnd:dword
	;	Mad wizard tutorial
	
	invoke WSAStartup,101h,addr wsadata
	.if eax!=0
		xor eax,eax
		dec eax
		ret
	.endif
	
;	invoke socket,AF_INET,SOCK_STREAM,0     ; Create a stream socket for internet use 
;	.if eax!=INVALID_SOCKET 
;	    mov sock,eax 
;		invoke WSAAsyncSelect,sock,hWnd,WM_FSOCKET,FD_CONNECT+FD_READ+FD_CLOSE+FD_WRITE+FD_ACCEPT
;	.else
;		invoke MessageBox,hWnd,CADD("Internet connection initialization error"),CADD("Unknown cause"),MB_OK
;	.endif
		
	
	ret
fInitInternet endp

fCloseInternet proc
	
	invoke closesocket,sock
	invoke WSACleanup
	
	ret
fCloseInternet endp

fConnect proc uses esi edi lpszHostName:dword,nPortNumber:dword
	
	mov sin.sin_family, AF_INET 
	invoke htons, nPortNumber
	mov sin.sin_port,ax
	invoke gethostbyname, lpszHostName
	.if eax==0
		xor eax,eax
		dec eax
		ret
	.endif
	mov eax,[eax+12]
	
	mov eax,[eax]                      ; copy the pointer to the actual IP address into eax 
	mov eax,[eax]                      ; copy IP address into eax 
	mov sin.sin_addr,eax 
	
	invoke connect,sock,addr sin,sizeof sin 
	.if eax==SOCKET_ERROR
		invoke WSAGetLastError          
	.endif 
	
	
	ret
fConnect endp


; The structure are
; [0] = socket
; 

fConnectToUrl proc uses esi edi lps:dword,hWnd:dword,lpszHostName:dword,nPort:dword
	LOCAL a:sockaddr_in	
	
	assume esi:ptr fInet
	mov esi,lps
	invoke socket,AF_INET,SOCK_STREAM,0     ; Create a stream socket for internet use 
	.if eax!=INVALID_SOCKET
		
	    mov [esi].sock,eax
		invoke WSAAsyncSelect,[esi].sock,hWnd,WM_FSOCKET,FD_CONNECT+FD_READ+FD_CLOSE+FD_WRITE+FD_ACCEPT
	.else
		invoke MessageBox,hWnd,CADD("Internet connection initialization error"),CADD("Unknown cause"),MB_OK
	.endif
	
	push lpszHostName
	pop [esi].lpszurl
	
	mov a.sin_family, AF_INET 
	invoke htons, nPort
	mov a.sin_port,ax
	invoke gethostbyname, lpszHostName
	.if eax==0
		invoke PERR
		ret
	.endif
	mov eax,[eax+12]
	
	mov eax,[eax]                      ; copy the pointer to the actual IP address into eax 
	mov eax,[eax]                      ; copy IP address into eax 
	mov a.sin_addr,eax 
	
	invoke connect,[esi].sock,addr a,sizeof a 
	.if eax==SOCKET_ERROR
		invoke WSAGetLastError  
		;invoke PERR
	.endif
	
	
	
	assume esi:nothing
	
	ret
fConnectToUrl endp

fBindToUrl proc uses esi edi lps:dword,hWnd:dword,lpszHostName:dword,nPort:dword
	LOCAL a:sockaddr_in	
	
	assume esi:ptr fInet
	mov esi,lps
	invoke socket,AF_INET,SOCK_STREAM,0     ; Create a stream socket for internet use 
	.if eax!=INVALID_SOCKET
		
	    mov [esi].sock,eax
		invoke WSAAsyncSelect,[esi].sock,hWnd,WM_FSOCKET,FD_CONNECT+FD_READ+FD_CLOSE+FD_WRITE+FD_ACCEPT
	.else
		invoke MessageBox,hWnd,CADD("Internet connection initialization error"),CADD("Unknown cause"),MB_OK
	.endif
	
	push lpszHostName
	pop [esi].lpszurl
	
	mov a.sin_family, AF_INET 
	invoke htons, nPort
	mov a.sin_port,ax
	invoke gethostbyname, lpszHostName
	.if eax==0
		invoke PERR
		ret
	.endif
	mov eax,[eax+12]
	
	mov eax,[eax]                      ; copy the pointer to the actual IP address into eax 
	mov eax,[eax]                      ; copy IP address into eax 
	mov a.sin_addr,eax 
	
	invoke bind,[esi].sock,addr a,sizeof a 
	.if eax==SOCKET_ERROR
		invoke WSAGetLastError  
		;invoke PERR
	.endif
	
	
	
	assume esi:nothing
	
	ret
fBindToUrl endp

fGetData proc uses esi edi lps:dword
	LOCAL buff[512]:dword
	
	assume esi:ptr fInet
	mov esi,lps
	
	invoke memfill,addr buff,512*4,0
	invoke lstrcat,addr buff,CADD("GET / HTTP/1.0")
	invoke lstrlen,addr buff
	lea ecx,buff
	add ecx,eax
	mov word ptr [ecx],0a0dh
	invoke lstrcat,addr buff,CADD("Host: ")
	invoke lstrcat,addr buff,[esi].lpszurl
	invoke lstrlen,addr buff
	lea ecx,buff
	add ecx,eax
	mov word ptr [ecx],0a0dh
	invoke lstrcat,addr buff,CADD("User Agent: Farabi x.0")
	invoke lstrlen,addr buff
	lea ecx,buff
	add ecx,eax
	mov word ptr [ecx],0a0dh
	add ecx,2
	mov word ptr[ecx],0a0dh
	
	
	invoke lstrlen,addr buff
	mov ecx,eax
	invoke send,[esi].sock,addr buff, ecx,0
	.if eax==SOCKET_ERROR
		invoke PERR
	.endif
	
	
	assume esi:nothing
	ret
fGetData endp

fSockAddHeader proc uses esi edi lps:dword, lptz:dword,nSize:dword
	LOCAL nReq:dword
	LOCAL nSizeT:dword
	
	mov esi,lps
	
	mov ecx,nSize
	
	.if ecx==-1
		invoke lstrlen,lptz
		push eax
		pop nSizeT
	.else
		push nSize
		pop nSizeT
	.endif
	
	.if [esi].fRequest.lpData==0
		invoke mAlloc,nSizeT
		mov [esi].fRequest.lpData,eax
		push nSizeT
		pop [esi].fRequest.nLenght
		invoke MemCopy,lptz,[esi].fRequest.lpData,[esi].fRequest.nLenght
		ret
	.endif
	
	mov ecx,[esi].fRequest.nLenght
	add ecx,nSizeT
	invoke mAlloc,ecx
	mov nReq,eax
	
	invoke MemCopy,[esi].fRequest.lpData,nReq,[esi].fRequest.nLenght
	mov eax,nReq
	add eax,[esi].fRequest.nLenght
	invoke MemCopy,lptz,eax,nSizeT
	
	invoke GlobalFree,[esi].fRequest.lpData
	push nReq
	pop [esi].fRequest.lpData
	mov eax,[esi].fRequest.nLenght
	add eax,nSizeT
	mov [esi].fRequest.nLenght,eax
	
	xor eax,eax
	
	ret
fSockAddHeader endp

fSockReleaseHeader proc uses esi edi lps:dword
	
	mov esi,lps
	push 0
	pop [esi].fRequest.nLenght
	invoke GlobalFree,[esi].fRequest.lpData
	push 0
	pop [esi].fRequest.lpData
	
	ret
fSockReleaseHeader endp

fSockUpload proc uses esi edi lps:dword,lpszObject:dword,lptzFileName:dword
	LOCAL hReq:dword
	LOCAL t:fRequest
	LOCAL u:fRequest
	LOCAL fl,filesz:dword
	LOCAL buff[256]:dword
	
	push 0
	pop t.nLenght
	push 0
	pop t.lpData
	
	push 0
	pop u.nLenght
	push 0
	pop u.lpData
	
	mov hReq,0
	mov esi,lps
	
	invoke filesize,lptzFileName
	.if eax==-1
		jmp fail
	.endif
	mov filesz,eax
	
	invoke mAlloc,filesz
	mov fl,eax
	
	invoke read_disk_file,lptzFileName,addr fl,addr filesz
	
	invoke fSockAddHeader,addr t,CADD("GET "),-1
	invoke fSockAddHeader,addr t,[esi].fInet.lpszurl,-1
	invoke fSockAddHeader,addr t,CADD("/"),-1
	invoke fSockAddHeader,addr t,lpszObject,-1
	invoke fSockAddHeader,addr t,CADD(" HTTP/1.1"),-1
	invoke fSockAddHeader,addr t,CADD(13,10),-1
	
	invoke fSockAddHeader,addr t,CADD("Host: "),-1
	invoke fSockAddHeader,addr t,[esi].fInet.lpszurl,-1
	invoke fSockAddHeader,addr t,CADD(13,10),-1
	invoke fSockAddHeader,addr t,CADD(13,10),-1
	
	
	invoke fSockAddHeader,addr t,CADD("User-Agent: Mozilla/5.0"),-1
	invoke fSockAddHeader,addr t,CADD(13,10),-1
	
	invoke fSockAddHeader,addr t,CADD("Accept: text/html,application/xhtml+xml,application/xml;q=0.9,*/*;q=0.8"),-1
	invoke fSockAddHeader,addr t,CADD(13,10),-1
	
	invoke fSockAddHeader,addr t,CADD("Accept-Charset: ISO-8859-1,utf-8;q=0.7,*;q=0.7"),-1
	invoke fSockAddHeader,addr t,CADD(13,10),-1
	
	invoke fSockAddHeader,addr t,CADD("Keep Alive: 300"),-1
	invoke fSockAddHeader,addr t,CADD(13,10),-1
	
	invoke fSockAddHeader,addr t,CADD("Connection: keep-alive"),-1
	invoke fSockAddHeader,addr t,CADD(13,10),-1
	
;	invoke fSockAddHeader,addr t,CADD("Referer: http://localhost/uploadform.php"),-1
;	invoke fSockAddHeader,addr t,CADD(13,10),-1
	
;	invoke fSockAddHeader,addr t,CADD("Content-Type: application/x-www-form-urlencoded; boundary=-----1234"),-1
;	invoke fSockAddHeader,addr t,CADD(13,10),-1
	
;	invoke fSockAddHeader,addr t,CADD("Content-Length: "),-1
;	invoke dw2a,filesz,addr buff
;	invoke fSockAddHeader,addr t,addr buff,-1
;	invoke fSockAddHeader,addr t,CADD(13,10),-1
	
;	invoke fSockAddHeader,addr t,CADD("-----1234"),-1
;	invoke fSockAddHeader,addr t,CADD(13,10),-1
	
;	invoke fSockAddHeader,addr t,CADD('Content-Disposition: form-data; name="MAX_FILE_SIZE"'),-1
;	invoke fSockAddHeader,addr t,CADD(13,10),1
	
;	invoke fSockAddHeader,addr t,CADD('50000'),-1
;	invoke fSockAddHeader,addr t,CADD(13,10),1
	
;	invoke fSockAddHeader,addr t,CADD("-----1234"),-1
;	invoke fSockAddHeader,addr t,CADD(13,10),1
	
;	invoke fSockAddHeader,addr t,CADD('Content-Disposition: form-data; name="uploadedfile"; filename="test.inc"'),-1
;	invoke fSockAddHeader,addr t,CADD(13,10),-1
	
;	invoke fSockAddHeader,addr t,CADD('Content-Type: application/octet-stream'),-1
;	invoke fSockAddHeader,addr t,CADD(13,10),-1
;	invoke fSockAddHeader,addr t,CADD(13,10),-1
	
;	
;	invoke fSockAddHeader,addr t,fl,filesz
;	invoke fSockAddHeader,addr t,CADD(13,10),-1
;	
;	invoke fSockAddHeader,addr t,CADD("-----1234--"),-1
	
	
	invoke send,[esi].fInet.sock,t.lpData,t.nLenght,0
	.if eax==SOCKET_ERROR
		invoke PERR
	.endif
	invoke memfill,addr buff,1024,0
;	loop_recv:
;	invoke recv,[esi].fInet.sock,addr buff,1024,0
;	cmp eax,SOCKET_ERROR
;	jz @F
;	cmp eax,0
;	jz loop_recv
;	@@:
	;invoke MessageBox,0,addr buff,0,MB_OK
	
	
	invoke GlobalFree,t.lpData
	invoke GlobalFree,fl
	
	fail:
	
	ret
fSockUpload endp

fSockDownload proc uses edi esi lps:dword,lpszObject:dword,lptzFileName:dword
	
	
	ret
fSockDownload endp
